import usb


###################
### Define Part ###
###################
VENDOR_RQ_GET_LIGHT0 = 0
VENDOR_RQ_GET_LIGHT1 = 1
VENDOR_RQ_GET_LIGHT2 = 2
VENDOR_RQ_GET_LIGHT3 = 3
VENDOR_RQ_GET_LIGHT4 = 4
VENDOR_RQ_GET_LIGHT5 = 5


###############
### Classes ###
###############
class Board:
	def __init__(self):
		print "Looking for MCU board..."
		dev = self.find_board()
		if not dev: raise "MCU board not found!"
		print "MCU board found"
		self.handle = dev.open()

	def find_board(self):
		for bus in usb.busses():
			for dev in bus.devices:
				if dev.idVendor == 0x16c0 and dev.idProduct == 0x05dc:
					return dev
		return None

	#get light from port PC0
	def get_light0(self):
		reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
		light = self.handle.controlMsg(reqType, VENDOR_RQ_GET_LIGHT0, 2)
		return light[0] + light[1]*256

	#get light from port PC1
	def get_light1(self):
		reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
		light = self.handle.controlMsg(reqType, VENDOR_RQ_GET_LIGHT1, 2)
		return light[0] + light[1]*256

	#get light from port PC2
	def get_light2(self):
		reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
		light = self.handle.controlMsg(reqType, VENDOR_RQ_GET_LIGHT2, 2)
		return light[0] + light[1]*256

	#get light from port PC3
	def get_light3(self):
		reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
		light = self.handle.controlMsg(reqType, VENDOR_RQ_GET_LIGHT3, 2)
		return light[0] + light[1]*256

	#get light from port PC4
	def get_light4(self):
		reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
		light = self.handle.controlMsg(reqType, VENDOR_RQ_GET_LIGHT4, 2)
		return light[0] + light[1]*256

	#get light from port PC5
	def get_light5(self):
		reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
		light = self.handle.controlMsg(reqType, VENDOR_RQ_GET_LIGHT5, 2)
		return light[0] + light[1]*256
